require 'active_record'
require 'yaml'

require_relative 'users'
require_relative 'projects'

module Trackington
  class Application
    attr_reader :users, :projects

    def initialize(connection_config = nil)
      @users = UserRepository.new
      @projects = ProjectRepository.new

      establish_connection(connection_config)
    end

    private

    def establish_connection(config)
      if config.nil?
        config_path = File.expand_path('../../db/config.yml', __FILE__)
        config = YAML.load(IO.read(config_path))

        env = ENV['DB'] || 'development'

        ActiveRecord::Base.establish_connection(config[env])
      else
        ActiveRecord::Base.establish_connection(config)
      end
    end
  end
end
